precision highp float;

uniform vec4 u_color;
uniform float u_hardness;
varying highp vec2 v_texCoord;


const float gray_steps = 255.0;
float nrand(vec2 n) {
    return fract(sin(dot(n.xy, vec2(12.9898, 78.233))) * 43758.5453);
}

void main() {
    float dist = smoothstep(u_hardness, 1.0, distance(v_texCoord, vec2(0.5, 0.5)) * 2.0);
    vec4 color = u_color + vec4(nrand(v_texCoord) / gray_steps);
    gl_FragColor = clamp(floor(color * (1.0 - dist) * gray_steps) / gray_steps, 0.0, 1.0);
}